<template>
  <section>
    <h3 class="mt-4">
      <strong>Form</strong> {{ form.id }}
    </h3>
    <div class="form-wrapper">
      <form
        class="form bg-white shadow-md rounded px-8 pt-6 pb-8 mb-4"
        @submit.prevent="submitForm"
      >
        <div
          v-for="item of form.fields"
          :key="item.id"
        >
          <input-field
            v-if="item.type === 'text'"
            v-model="formData.name"
            class="form-input"
            :placeholder="item.name"
            :reg-exp="item.validation"
            :required="item.required"
            :toggle-valid-form="toggleValidForm('name')"
          />
          <text-area-field
            v-else-if="item.type === 'text-multiline'"
            v-model="formData.text"
            :placeholder="item.name"
            :required="item.required"
            :reg-exp="item.validation"
            :toggle-valid-form="toggleValidForm('text')"
          />
          <select-field
            v-else-if="item.type === 'select'"
            v-model="formData.select"
            :default-name="item.name"
            :default-value="item.name"
            :options="item.options"
            :required="item.required"
            :reg-exp="item.validation"
            :toggle-valid-form="toggleValidForm('select')"
          />
        </div>
        <button
          :disabled="!isValid"
          :class="{'is-disabled' : !isValid}"
          class="bg-blue-500 hover:bg-blue-700
          text-white font-bold py-2 px-4 rounded focus:outline-none focus:shadow-outline"
          type="submit"
        >
          Submit
        </button>
      </form>
    </div>
  </section>
</template>

<script lang="ts">
import {
  reactive, defineComponent, PropType, computed,
} from 'vue';
import { mapGetters } from 'vuex';
import axios from 'axios';
import TextAreaField from '@/components/ui/TextAreaField.vue';
import SelectField from '@/components/ui/SelectField.vue';
import InputField from '@/components/ui/InputFiled.vue';
import { FormInterface } from '@/interfaces';

export default defineComponent({

  name: 'Form',
  components: { InputField, SelectField, TextAreaField },
  setup() {
    const formData = reactive({
      name: '',
      text: '',
      select: '',
    });
    const validationFormInfo = reactive({
      name: false,
      text: false,
      select: false,
    });

    const isValid = computed(() => Object.values(validationFormInfo)
      .filter((item) => item).length === 3);

    const toggleValidForm = (field: 'name' | 'text' | 'select') => (value: boolean) => {
      validationFormInfo[field] = value;
    };

    const submitForm = async () => {
      try {
        await axios.post('https://httpbin.org/post', formData)
          .then((res) => {
            if (res.status === 200 || res.status === 201) {
              alert('Success');
            }
          });
      } catch (e) {
        console.log(e);
      }
    };

    return {
      formData, validationFormInfo, isValid, toggleValidForm, submitForm,
    };
  },
  data() {
    return {
      form: Object as PropType<FormInterface>,
    };
  },
  computed: {
    ...mapGetters({
      getFormById: 'getFormById',
    }),
  },
  updated() {
    this.setData();
  },
  mounted() {
    this.setData();
  },
  methods: {
    setData() {
      this.form = this.getFormById(this.$route.params.id);
    },
  },
});
</script>

<style scoped>
.form-wrapper {
  display: flex;
  justify-content: center;
  margin-top: 50px;
}
  .form {
      min-width: 600px;
  }
  .is-disabled {
    background-color: red;
  }
</style>
